#pragma once
#include <atlctrls.h>

// UDT RAPT
#include "SearchBarEditor.h"
// ENDE

class CSearchBarCtrlBase : public CComboBoxEx
{
public:

};

template <class T, class TBase = CSearchBarCtrlBase, class TWinTraits = CControlWinTraits>
class ATL_NO_VTABLE CSearchBarCtrlImpl :
	public CWindowImpl< T, TBase, TWinTraits >,
	public IDropTargetImpl<T>,
	public IDropSourceImpl<T>
{
public:
	typedef CWindowImpl< T, TBase, TWinTraits > baseClass;
	DECLARE_WND_SUPERCLASS(NULL, TBase::GetWndClassName())

	struct CGoBtnInfo
	{
		CGoBtnInfo(UINT nImageBmpID, UINT nHotImageBmpID, int cx, int cy, COLORREF clrMask, UINT nFlags)
			: _nImageBmpID(nImageBmpID), _nHotImageBmpID(nHotImageBmpID), _cx(cx), _cy(cy), 
			  _clrMask(clrMask), _nFlags(nFlags) { }

		UINT _nImageBmpID;
		UINT _nHotImageBmpID;
		int _cx, _cy;
		COLORREF _clrMask;
		UINT _nFlags;
	};

	DWORD m_dwSearchBarExtendedStyle;

// Data members
	CToolBarCtrl m_wndToolBar;
	CContainedWindow m_wndCombo;
	CContainedWindow m_wndComboCate;
	CContainedWindowT<CEdit> m_wndEdit;
	CFlatComboBox m_cmbThis;
	CFlatComboBox m_cmbCate;
	int m_cx;
	int m_cxBtnsBtn;
	int m_cxCmbCate;
	SIZE m_szBtnsIcon;
	int m_nGoBtnCmdID;
	UINT m_nIDWeb;
	UINT m_nImgBmpID, m_nHotImgBmpID;
	enum { s_kcxGap = 2 };
	bool m_bDragFromItself;

	int m_nBmpCx, m_nBmpCy;
	CFont m_font; // UDT RAPT

	CSearchBarCtrlImpl() : 
		m_dwSearchBarExtendedStyle(0),
		m_wndCombo(this, 1),
		m_wndEdit(this, 2),
		m_wndComboCate(this, 3),
		m_bDragFromItself(false)
	{
	}

	HWND Create(HWND hWndParent, UINT nID, UINT nIDWeb,
		UINT nImageBmpID, UINT nHotImageBmpID,
		int cx, int cy, COLORREF clrMask, UINT nFlags = ILC_COLOR8)
	{
		m_nIDWeb = nIDWeb;
		m_nImgBmpID = nImageBmpID;
		m_nHotImgBmpID = nHotImageBmpID;

		m_nBmpCx = cx;
		m_nBmpCy = cy;
		return baseClass::Create(hWndParent, CRect(0, 0, 0, 250),
			NULL, ABR_PANE_STYLE | CBS_DROPDOWN | CBS_AUTOHSCROLL , 0, nID);
	}
// Attributes
	bool GetDroppedStateEx() const
	{
		return (GetDroppedState() || _AutoCompleteWindowVisible());
	}

// Message map and handlers
	BEGIN_MSG_MAP(CSearchBarCtrlBaseImpl)
		MSG_WM_CREATE(OnCreate)
		MSG_WM_DESTROY(OnDestroy)
		MSG_WM_COMMAND(OnCommand)
		MSG_WM_SIZE(OnSize)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBackground)
		MESSAGE_HANDLER(WM_WINDOWPOSCHANGING, OnWindowPosChanging)
	ALT_MSG_MAP(1)
		MESSAGE_HANDLER(WM_WINDOWPOSCHANGING, OnComboWindowPosChanging)
	ALT_MSG_MAP(2)
		MSG_WM_KEYDOWN(OnEditKeyDown)
	ALT_MSG_MAP(3)
		MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDownCate)
		MSG_WM_COMMAND(OnCommandCate) // UDT RAPT
	END_MSG_MAP()

	HRESULT OnGetSearchBarCtrlDataObject(IDataObject** ppDataObject)
	{
		ATLASSERT(ppDataObject != NULL);
		*ppDataObject = NULL;
		return E_NOTIMPL;
	}

	void OnEditKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
	{
		// if not dropped, eat VK_DOWN	
		if (!GetDroppedState() && !_AutoCompleteWindowVisible() && (nChar == VK_DOWN || nChar == VK_UP))
			SetMsgHandled(TRUE);
		else if (nChar == VK_RETURN) {
 			_OnEnterKeyDown();
			SetMsgHandled(TRUE);
		} else
			SetMsgHandled(FALSE);
	}

	void _OnEnterKeyDown()
	{
		CEdit edit = GetEditCtrl();
		CString str = MtlGetWindowText(edit);//some comboboxex control impl often not support GetWindowText
		if (!str.IsEmpty()) {
			if (_AutoCompleteWindowVisible())// I have to clean auto complete window, but escape means undo...
				::SendMessage(GetEditCtrl(), WM_KEYDOWN, (WPARAM)VK_ESCAPE, 0);
			T* pT = static_cast<T*>(this);
			pT->OnItemSelected(str);
			_AddToSearchBoxUnique(str);
		}
	}

	void _AddToSearchBoxUnique(const CString& strURL)
	{
		T* pT = static_cast<T*>(this);
		COMBOBOXEXITEM item;
		item.iItem = 0;// ado to top
		item.mask = CBEIF_TEXT;
		item.pszText = (LPTSTR)(LPCTSTR)strURL;

		// search the same string
		int nCount = GetCount();
		for (int n = 0; n < nCount; ++n) {
			CString str;
			MtlGetLBTextFixed(m_hWnd, n, str);
			if (strURL == str) {
				DeleteItem(n);
				break;
			}
		}

		InsertItem(&item);
	}

	bool _AutoCompleteWindowVisible() const
	{
		CRect rc; m_wndEdit.GetWindowRect(&rc);
		CPoint pt(rc.left + 1, rc.bottom + 5);
		HWND hWndDropDown = ::WindowFromPoint(pt);
		if (MtlIsFamily(m_hWnd, hWndDropDown))
			return false;
		else
			return true;

//		HWND hWnd = ::FindWindow(_T("Auto-Suggest Dropdown"), NULL);
//		return ::IsWindowVisible(hWnd) == TRUE;
	}

	void OnCommand(UINT, int nID, HWND hWndCtrl)
	{
		if (hWndCtrl == m_wndToolBar.m_hWnd) {
			ATLASSERT(nID == m_nIDWeb);
			CEdit edit = GetEditCtrl();
			CString str = MtlGetWindowText(edit);

			// UDT RAPT : permit Empty
			T* pT = static_cast<T*>(this);
			pT->OnItemSelected(str);
			// ENDE
			if (!str.IsEmpty()) {
				_AddToSearchBoxUnique(str);
			}
		}
		else {
			SetMsgHandled(FALSE);
		}
	}
	
	// UDT RAPT
	void OnCommandCate(UINT, int nID, HWND /*hWndCtrl*/)
	{
		ATLASSERT(nID == m_nIDWeb);
		CEdit edit = GetEditCtrl();
		CString str = MtlGetWindowText(edit);
		
		if (!str.IsEmpty()) {
			T* pT = static_cast<T*>(this);
			pT->OnItemSelected(str);
			_AddToSearchBoxUnique(str);
		}
		CSearchBarOption::s_dwListCountSelect = m_cmbCate.GetCurSel();
	}
	// ENDE

	LRESULT OnLButtonDownCate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		POINT pt = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
		m_cmbCate.ShowDropDown();
		//bSbrOnDownSearchListBox = true;
		return 0;
	}

// Methods
	BYTE PreTranslateMessage(MSG* pMsg)
	{
		UINT msg = pMsg->message;
		int vKey =  pMsg->wParam;

		if (msg == WM_SYSKEYDOWN || msg == WM_SYSKEYUP || msg == WM_KEYDOWN) {

			if (!IsWindowVisible() || !IsChild(pMsg->hwnd))	// ignore
				return _MTL_TRANSLATE_PASS;

			// left or right pressed, check shift and control key.
			if (vKey == VK_UP || vKey == VK_DOWN || vKey == VK_LEFT || vKey == VK_RIGHT || vKey == VK_HOME || vKey == VK_END) {
				if (::GetKeyState(VK_SHIFT) < 0 || ::GetKeyState(VK_CONTROL) < 0)
					return _MTL_TRANSLATE_WANT;// pass to edit control
			}

			// return key have to be passed
			if (vKey == VK_RETURN) {
				return _MTL_TRANSLATE_WANT;
			}

			// other key have to be passed
			if (VK_LBUTTON <= vKey && vKey <= VK_HELP) {
				BOOL bAlt = HIWORD(pMsg->lParam) & KF_ALTDOWN;
				if (!bAlt && ::GetKeyState(VK_SHIFT) >= 0 && ::GetKeyState(VK_CONTROL) >= 0)// not pressed
					return _MTL_TRANSLATE_WANT;// pass to edit control
			}
		}

		return _MTL_TRANSLATE_PASS;
	}


	void InitCategoryCombo()
	{
		m_cxCmbCate = 100;
		// UDT RAPT
		CString strSearchPath = CSearchBarOption::GetSearchPath();
		{
			CIniSection pr;
			DWORD dwCmbCate_cx;
			pr.Open(strSearchPath, _T("SearchBar"));
			long lRet = pr.QueryValue(dwCmbCate_cx, _T("CategoryCx"));
			if (lRet == ERROR_SUCCESS)
				m_cxCmbCate = dwCmbCate_cx;
			pr.Close();
		}
		// ENDE
		CRect rect(0, 0, m_cxCmbCate, 200);
		m_cmbCate.Create(m_hWnd, rect, NULL, ABR_PANE_STYLE | CBS_DROPDOWNLIST | CBS_AUTOHSCROLL | WS_VSCROLL, 0, IDC_SEARCHBAR+5);
		m_cmbCate.SetDroppedWidth(125);

		ResetCategoryCombo(); // UDT RAPT
	}

	// UDT RAPT
	void ResetCategoryCombo() {
		m_cmbCate.ResetContent();

		CString strSearchPath = CSearchBarOption::GetSearchPath();

		CIniSection pr;
		DWORD dwListCount = 0;
		pr.Open(strSearchPath, _T("Search-List"));
		pr.QueryValue(dwListCount, _T("ListCount"));
		for (int i = 1; i <= dwListCount; i++) {
			CString strKey;
			strKey.Format(_T("%02d"), i); // UDT RAPT
			TCHAR szBuff[MAX_PATH];

			DWORD dwCount = MAX_PATH;
			pr.QueryValue(szBuff, strKey, &dwCount);

			CString strTitle(szBuff);
			if (strTitle.IsEmpty()) continue;

			m_cmbCate.AddString(strTitle);
		}
		m_cmbCate.SetCurSel(CSearchBarOption::s_dwListCountSelect); // UDT RAPT
		pr.Close();

		CSearchBarOption::s_bMustResetSearchBar = false;
	}

	void InitFont()
	{
		CLogFont lf;
		lf.InitDefault();

		CIniSection prFont;
		prFont.Open(CSearchBarOption::GetSearchPath(), _T("SearchBar"));
		if (!lf.GetProfile(prFont)) // error
			lf.RtlMakeFont(_T("MS UI Gothic"), 9, 400, 0, 0, 0, 128); // default
		prFont.Close();

		CFontHandle font;
		MTLVERIFY(font.CreateFontIndirect(&lf));
		if (font.m_hFont) {
			if(m_font.m_hFont != NULL)
				m_font.DeleteObject();
			m_font.Attach(font.m_hFont);
			SetFont(m_font);
		}
	}
	// ENDE

	LRESULT OnCreate(LPCREATESTRUCT)
	{
		InitToolBar(m_nIDWeb, m_nImgBmpID, m_nHotImgBmpID, m_nBmpCx, m_nBmpCy, RGB(255,0,255));
		InitCategoryCombo();

		// default
		LRESULT lRet = DefWindowProc();

		_ShowButton(true);
		
		m_wndComboCate.SubclassWindow(m_cmbCate.m_hWnd);

		m_wndCombo.SubclassWindow(GetComboCtrl());
		m_wndEdit.SubclassWindow(GetEditCtrl());
		m_cmbThis.FlatComboBox_Install(GetComboCtrl());

		InitFont(); // UDT RAPT

		T* pT = static_cast<T*>(this);
		pT->OnInit();

		return lRet;
	}

	void SetFont(HFONT hFont, BOOL bRedraw=TRUE)
	{
		// CSearchBarCtrlBase::SetFont(hFont, bRedraw);
		// m_cmbCate.SetFont(hFont, bRedraw);
		::SendMessage( m_cmbCate, WM_SETFONT, (WPARAM)hFont, bRedraw);
	}

	void OnDestroy()
	{
		MtlDestroyImageLists(m_wndToolBar);

		m_wndCombo.UnsubclassWindow();
		m_wndEdit.UnsubclassWindow();
		m_wndComboCate.UnsubclassWindow();

		T* pT = static_cast<T*>(this);
		pT->OnTerm();
	}

	void OnSize(UINT nFlags, CSize size)
	{
		int cxGo = _GetToolBarWidth();
		int cxCate = _GetCmbCateWidth();
		CRect rc; GetClientRect(rc);

		m_cmbCate.MoveWindow(rc.right - cxGo - cxCate + s_kcxGap, 0, cxCate-s_kcxGap, rc.Height()*20);
		InvalidateRect(CRect(rc.right - (m_cxCmbCate) - (cxGo), 0, rc.right - (m_cxCmbCate + s_kcxGap ) - (cxGo + s_kcxGap), rc.Height()));

		m_wndToolBar.MoveWindow(rc.right - cxGo+ s_kcxGap, 0, cxGo, rc.Height());
		InvalidateRect(CRect(rc.right - cxGo, 0, rc.right - cxGo + s_kcxGap, rc.Height()));
	}

	LRESULT OnEraseBackground(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled)
	{
// UDT RAPT (JOBBY)
//		RECT rect;
//		GetClientRect(&rect);
//		::FillRect((HDC)wParam, &rect, (HBRUSH)LongToPtr(COLOR_3DFACE + 1));
//		return 1;	// don't do the default erase
		HWND hWnd = GetParent();
		CPoint pt(0, 0);
		MapWindowPoints(hWnd, &pt, 1);
		pt = ::OffsetWindowOrgEx((HDC)wParam, pt.x, pt.y, NULL);
		LRESULT lResult = ::SendMessage(hWnd, WM_ERASEBKGND, wParam, 0L);
		::SetWindowOrgEx((HDC)wParam, pt.x, pt.y, NULL);
		return lResult;
// ENDE
	}

	void InitToolBar(int nIDWeb,
					 UINT nImageBmpID, UINT nHotImageBmpID, 
					 int cx, int cy, COLORREF clrMask, UINT nFlags = ILC_COLOR8)
	{
		CImageList imgs;
		MTLVERIFY(imgs.Create(cx, cy, nFlags | ILC_MASK, 1, 1));

		CBitmap bmp;
		MTLVERIFY(bmp.LoadBitmap(nImageBmpID));
		imgs.Add(bmp, clrMask);

		CImageList imgsHot;
		MTLVERIFY(imgsHot.Create(cx, cy, nFlags | ILC_MASK, 1, 1));

		CBitmap bmpHot;
		MTLVERIFY(bmpHot.LoadBitmap(nHotImageBmpID));
		imgsHot.Add(bmpHot, clrMask);

		m_wndToolBar = ::CreateWindowEx(0, TOOLBARCLASSNAME, NULL,
			ATL_SIMPLE_TOOLBAR_PANE_STYLE | TBSTYLE_LIST | CCS_TOP, 0,0,100,100,
				m_hWnd, (HMENU)12, _Module.GetModuleInstance(), NULL);
		m_wndToolBar.SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);
		m_wndToolBar.SetButtonStructSize(sizeof(TBBUTTON));

		m_wndToolBar.SetImageList(imgs);
		m_wndToolBar.SetHotImageList(imgsHot);

		// add Add and Organize button
		TBBUTTON btnWeb = { 0, nIDWeb, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0 };
		MTLVERIFY(m_wndToolBar.InsertButton(-1, &btnWeb));

//		CVersional<TBBUTTONINFO> bi;
//		bi.dwMask = TBIF_TEXT;
//		bi.pszText = _T("");
//		MTLVERIFY(m_wndToolBar.SetButtonInfo(nIDWeb, &bi));

		m_wndToolBar.AddStrings(_T("Search\0"));	// for proper item height
		m_cxBtnsBtn = _CalcBtnWidth(cx, _T(""));
		m_wndToolBar.SetButtonWidth(_GetToolBarWidth()-2, _GetToolBarWidth()-2);
	}

	// Strangly GetButtonInfo lies...
	int _CalcBtnWidth(int cxIcon, const CString& strText)
	{
		const int cxGap = 3;

		if (strText.IsEmpty())
			return cxGap*2 + cxIcon;

		int nWidth = 0;
		nWidth += cxGap*2;
		nWidth += cxIcon;
		nWidth += cxGap*2 - 1;
		nWidth += MtlComputeWidthOfText(strText, m_wndToolBar.GetFont());
		return nWidth;
	}

	LRESULT OnWindowPosChanging(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
	{
		LPWINDOWPOS lpWP = (LPWINDOWPOS)lParam;
		m_cx = lpWP->cx;

		LRESULT lRet = DefWindowProc(uMsg, wParam, lParam);

		if (m_wndToolBar.m_hWnd) {
			CSize size; m_wndToolBar.GetButtonSize(size);
			if(lpWP->cy < size.cy)
				lpWP->cy = size.cy;
		}

		return lRet;
	}

	LRESULT OnComboWindowPosChanging(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
	{
		LRESULT lRet = m_wndCombo.DefWindowProc(uMsg, wParam, lParam);
		LPWINDOWPOS lpWP = (LPWINDOWPOS)lParam;
		lpWP->cx = m_cx - _GetToolBarWidth() - _GetCmbCateWidth();
		return lRet;
	}

	void _ShowButton(bool bShow)
	{
		if (bShow)
			m_wndToolBar.ShowWindow(SW_SHOWNORMAL);
		else
			m_wndToolBar.ShowWindow(SW_HIDE);

//		SendMessage(WM_SIZE, 0, 0);// update layout of go button

		// generate WM_WINDOWPOSCHANGING, no other way
		CRect rect;
		GetWindowRect(rect);
		CWindow(GetParent()).ScreenToClient(rect);

		SetWindowPos(NULL, rect.left, rect.top,
				rect.right - rect.left - 1, rect.bottom - rect.top,
				SWP_NOZORDER|SWP_NOREDRAW);// | SWP_NOACTIVATE);

		SetWindowPos(NULL, rect.left, rect.top,
				rect.right - rect.left, rect.bottom - rect.top,
				SWP_NOZORDER);// | SWP_NOACTIVATE);
	}

	int _GetToolBarWidth()
	{
		return m_cxBtnsBtn + s_kcxGap;
	}

	int _GetCmbCateWidth()
	{
		return m_cxCmbCate + s_kcxGap;
	}

// Overridables
	void OnItemSelected(const CString& str)
	{
	}

	void OnInit()
	{
	}

	void OnTerm()
	{
	}
};


class CSearchBarCtrl : public CSearchBarCtrlImpl<CSearchBarCtrl>
{
public:
	DECLARE_WND_SUPERCLASS(_T("MTL_SearchBar"), GetWndClassName())
};

//////////////////////
// for Donut
class CDonutSearchBar:
	public CSearchBarCtrlImpl<CDonutSearchBar>,
	public CCustomDraw<CDonutSearchBar>
{
public:
	int m_nCtrlKeyState; // UDT RAPT

	DECLARE_WND_SUPERCLASS(_T("Donut_SearchBar"), GetWndClassName())

	CDonutSearchBar() : m_nCtrlKeyState(0) // UDT RAPT
	{
	}

	~CDonutSearchBar()
	{
	}

	// required for stupid OnCustomDraw including pT->SetMsgHandled
	void SetMsgHandled(BOOL bHandled)
	{
		CSearchBarCtrlImpl<CDonutSearchBar>::SetMsgHandled(bHandled);
	}

	BOOL IsMsgHandled() const
	{
		return CSearchBarCtrlImpl<CDonutSearchBar>::IsMsgHandled();
	}

// Custom draw overrides
	DWORD OnPrePaint(int /*idCtrl*/, LPNMCUSTOMDRAW /*lpNMCustomDraw*/)
	{
		return CDRF_NOTIFYITEMDRAW;	// we need per-item notifications
	}

	// OnItemPostPaint not called
	DWORD OnItemPrePaint(int idCtrl, LPNMCUSTOMDRAW lpNMCustomDraw)
	{
		return CDRF_DODEFAULT;
	}

	void OnItemSelected(const CString& str)
	{
		int nTarCate = m_cmbCate.GetCurSel();
		if (nTarCate == -1)
			return;

		TCHAR szBuff[MAX_PATH];
		memset(szBuff, 0, MAX_PATH);
		m_cmbCate.GetLBText(nTarCate, szBuff);
		CString strSearchEng(szBuff);

		// UDT RAPT
		m_nCtrlKeyState = 0;
		if (::GetAsyncKeyState(VK_SHIFT) < 0)
			m_nCtrlKeyState |= VK_SHIFT;
		if (::GetAsyncKeyState(VK_CONTROL) < 0)
			m_nCtrlKeyState |= VK_CONTROL;
		if (::GetAsyncKeyState(VK_MENU) < 0)
			m_nCtrlKeyState |= VK_MENU;
		// ENDE
		
		BOOL bFirst=TRUE;
		int nLoopCtn=0;
		OpenSearch(str, strSearchEng, nLoopCtn, bFirst);
	}

	void OpenSearch(CString strWord, CString strSearchEng, int &nLoopCnt, BOOL &bFirst)
	{
		bool bIsShellExec = false; // UDT RAPT

		CString strSearchPath = CSearchBarOption::GetSearchPath();
		CIniSection pr;
		pr.Open(strSearchPath, strSearchEng);

		DWORD dwGroup=0;
		pr.QueryValue(dwGroup, _T("Group"));
		BOOL bGroup = (dwGroup > 0)? TRUE: FALSE; // UDT RAPT

		if (bGroup)
			OpenSearchGroup(strWord, strSearchEng, nLoopCnt, bFirst);
		else {
			CString strOpenURL;
			DWORD dwCount = MAX_PATH;
			TCHAR szBuff[MAX_PATH];
			memset(szBuff, 0, MAX_PATH);
			pr.QueryValue(szBuff, _T("URL"), &dwCount);
			CString strURL(szBuff);
			if (strURL.IsEmpty()) {
				// compatible for DonutP
				pr.QueryValue(szBuff, _T("FrontURL"), &dwCount);
				CString strFront(szBuff);
				if (strFront.IsEmpty())
					return; // no data

				pr.QueryValue(szBuff, _T("BackURL"), &dwCount);
				CString strBack(szBuff);

				strOpenURL.Format(_T("%s%s%s"), strFront, strWord, strBack);
			} else {
				if (MtlIsExt(strURL, _T(".exe"))) {
					strOpenURL = strURL;
					bIsShellExec = true;
				}
				else
					strOpenURL.Format("%s%s", strURL, strWord);
			}

			DWORD dwOpenFlags = 0;
			if (bFirst) {
				dwOpenFlags |= D_OPENFILE_ACTIVATE;
				// UDT RAPT
				if (m_nCtrlKeyState & VK_SHIFT)
					dwOpenFlags |= D_OPENFILE_NOCREATE;
				// ENDE
				bFirst = FALSE;
			}
			// UDT RAPT
			if (m_nCtrlKeyState & VK_CONTROL)
				dwOpenFlags |= D_OPENFILE_NOSETFOCUS;
			m_nCtrlKeyState = 0; // refresh

			if (bIsShellExec)
				::ShellExecute(NULL, _T("open"), strOpenURL, NULL, NULL, SW_SHOWNORMAL);
			else
			// ENDE
				DonutOpenFile(m_hWnd, strOpenURL, dwOpenFlags);
		}

		pr.Close();
	}

//	void OpenSearchGroup(CString strWord, CString strSearchEng, int &nLoopCnt, BOOL &bFirst)
	void OpenSearchGroup(CString strWord, CString strSearchEng, int &nLoopCnt, BOOL &bFirst, bool bNoAppendExtraStr = false) // UDT RAPT
	{
		nLoopCnt++;
		if (nLoopCnt>10)
			return;

		CString strSearchPath = CSearchBarOption::GetSearchPath();
		CIniSection pr;
		pr.Open(strSearchPath, strSearchEng);

		DWORD dwListCnt = 0;
		pr.QueryValue(dwListCnt, _T("ListCount"));
		for (int i = 1; i <= dwListCnt; i++) {
			CString strKey;
			strKey.Format("%02d", i);
			TCHAR szBuff[MAX_PATH];
			DWORD dwCount = MAX_PATH;

			pr.QueryValue(szBuff, strKey, &dwCount);

			CString strSearchEng2(szBuff);
			if (strSearchEng2.IsEmpty())
				continue;

			OpenSearch(strWord, strSearchEng2, nLoopCnt, bFirst);
		}
	}

	void OnInit()
	{
		RegisterDragDrop();
	}

	void OnTerm()
	{
		RevokeDragDrop();
	}

	bool m_bDragAccept;
	DROPEFFECT OnDragEnter(IDataObject* pDataObject, DWORD dwKeyState, CPoint point)
	{
		if (m_bDragFromItself)
			return DROPEFFECT_NONE;

		_DrawDragEffect(false);

		m_bDragAccept = _MtlIsHlinkDataObject(pDataObject);
		return _MtlStandardDropEffect(dwKeyState);
	}

	DROPEFFECT OnDragOver(IDataObject* pDataObject, DWORD dwKeyState, CPoint point, DROPEFFECT dropOkEffect)
	{
		if (m_bDragFromItself || !m_bDragAccept)
			return DROPEFFECT_NONE;

		return _MtlStandardDropEffect(dwKeyState) | _MtlFollowDropEffect(dropOkEffect) | DROPEFFECT_COPY;
	}
	void OnDragLeave()
	{
		if (m_bDragFromItself)
			return;

		_DrawDragEffect(true);
	}

	void _DrawDragEffect(bool bRemove)
	{
		CClientDC dc(m_wndCombo.m_hWnd);

		CRect rect; m_wndCombo.GetClientRect(rect);

		if (bRemove)
			MtlDrawDragRectFixed(dc.m_hDC, &rect, CSize(0, 0), &rect, CSize(2, 2), NULL, NULL);
		else
			MtlDrawDragRectFixed(dc.m_hDC, &rect, CSize(2, 2), NULL, CSize(2, 2),	NULL, NULL);
	}

	DROPEFFECT OnDrop(IDataObject* pDataObject,	DROPEFFECT dropEffect,
		DROPEFFECT dropEffectList, CPoint point)
	{
		if (m_bDragFromItself)
			return DROPEFFECT_NONE;

		_DrawDragEffect(true);

		CString strText;
		if ( MtlGetHGlobalText(pDataObject, strText) ||
			 MtlGetHGlobalText(pDataObject, strText, ::RegisterClipboardFormat(CFSTR_SHELLURL)) )
		{
			CEdit edit = GetEditCtrl();
			edit.SetWindowText(strText);

			OnItemSelected(strText);
			_AddToSearchBoxUnique(strText);
			return DROPEFFECT_COPY;
		}

		return DROPEFFECT_NONE;
	}

	HRESULT OnGetSearchBarCtrlDataObject(IDataObject** ppDataObject)
	{
		ATLASSERT(ppDataObject != NULL);

		HRESULT hr = CHlinkDataObject::_CreatorClass::CreateInstance(NULL, IID_IDataObject, (void**)ppDataObject);
		if (FAILED(hr)) {
			*ppDataObject = NULL;
			return E_NOTIMPL;
		}

#ifdef _ATL_DEBUG_INTERFACES
		ATLASSERT(FALSE && _T("_ATL_DEBUG_INTERFACES crashes the following\n"));
#endif
		CHlinkDataObject* pHlinkDataObject = NULL;// this is hack, no need to release
		hr = (*ppDataObject)->QueryInterface(IID_NULL, (void**)&pHlinkDataObject);
		if (SUCCEEDED(hr)) {
			HWND hWnd = DonutGetActiveWindow(GetTopLevelParent());
			if (hWnd == NULL)
				return E_NOTIMPL;

			ATLASSERT(::IsWindow(hWnd));
			CWebBrowser2 browser = DonutGetIWebBrowser2(hWnd);
			if (browser.IsBrowserNull())
				return E_NOTIMPL;

			CString strName = MtlGetWindowText(hWnd);
			CString strUrl = browser.GetLocationURL();
			if (strUrl.IsEmpty())
				return E_NOTIMPL;

			if (strUrl.Left(5) == _T("file:")) {// Donut, to be explorer or not
				strName.Empty();
				strUrl = strUrl.Right(strUrl.GetLength() - 8);
				strUrl.Replace(_T('/'), _T('\\'));
			}
			pHlinkDataObject->m_arrNameAndUrl.Add(std::make_pair(strName, strUrl));
		}

		return S_OK;
	}
};
